'use strict';

var eventInfo = require('../events/event-info.js');
var Feature = require('../../../../../../motion-dom@12.38.0/node_modules/motion-dom/dist/es/render/Feature.js');
var hover = require('../../../../../../motion-dom@12.38.0/node_modules/motion-dom/dist/es/gestures/hover.js');
var frame = require('../../../../../../motion-dom@12.38.0/node_modules/motion-dom/dist/es/frameloop/frame.js');

function handleHoverEvent(node, event, lifecycle) {
    const { props } = node;
    if (node.animationState && props.whileHover) {
        node.animationState.setActive("whileHover", lifecycle === "Start");
    }
    const eventName = ("onHover" + lifecycle);
    const callback = props[eventName];
    if (callback) {
        frame.frame.postRender(() => callback(event, eventInfo.extractEventInfo(event)));
    }
}
class HoverGesture extends Feature.Feature {
    mount() {
        const { current } = this.node;
        if (!current)
            return;
        this.unmount = hover.hover(current, (_element, startEvent) => {
            handleHoverEvent(this.node, startEvent, "Start");
            return (endEvent) => handleHoverEvent(this.node, endEvent, "End");
        });
    }
    unmount() { }
}

exports.HoverGesture = HoverGesture;
